﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.SupplierPerformance;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;
@using Portal.Models.Globals;
@using Portal.Models.SupplierPerformance;

@Html.DevExpress().GridView(
    Grv => {
        Grv.Name = "GridSPReceive";
        //Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD; PART_NO; RECEIVING_AREA";
        Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD; RECEIVING_AREA";
        Grv.CallbackRouteValues = new { Controller = "SupplierPerformance", Action = "ReloadGridReceiveDetail" };
        Grv.ClientSideEvents.BeginCallback = "OnBeginCallback";
        Grv.ClientSideEvents.EndCallback = "OnEndCallback";
        Grv.Width = Unit.Percentage(100);
        Grv.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.SettingsBehavior.AllowDragDrop = false;
        
        Grv.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
        //setting.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        Grv.SettingsEditing.Mode = GridViewEditingMode.Inline;
        
        Grv.SettingsPager.PageSizeItemSettings.Visible = true;
        Grv.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        Grv.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        Grv.CommandColumn.Visible = true;
        Grv.CommandColumn.ClearFilterButton.Visible = true;
        //modif by alira.agi 2015-04-16
        Grv.CommandColumn.ShowSelectCheckbox = false;
        //Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.CommandColumn.ShowSelectCheckbox = false;
        Grv.CommandColumn.Width = Unit.Pixel(42);
        // remarks by alira.agi 2015-04-15
        //Grv.CommandColumn.SetHeaderTemplateContent(
        //    c =>
        //    {
        //        Html.DevExpress().CheckBox(
        //                chckBox =>
        //                {
        //                    chckBox.Name = "ChkBoxReceive";
        //                    chckBox.Properties.ClientSideEvents.CheckedChanged = "OnCheckAll";
        //                }
        //            ).Render();
        //    });
        
        Grv.Columns.Add(
            col => {
                col.Name = "ProductionMonth";
                col.Caption = "Production<br>Month";
                col.FieldName = "PROD_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SPMonthYear> pm = Model.GetModel<List<SPMonthYear>>();
                if (pm.Count() > 0)
                    pm.ForEach(s => cmdSuppCode.Items.Add(s.MonthYear));  
            });

        Grv.Columns.Add(
            col => {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);
                                
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SupplierICS> Supplier = Model.GetModel<List<SupplierICS>>();
                if (Supplier.Count() > 0)
                    Supplier.ForEach(s => cmdSuppCode.Items.Add(s.SUPP_CD));  
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });

        //Grv.Columns.Add(
        //    col => {
        //        col.Name = "PartNo";
        //        col.Caption = "Part No";
        //        col.FieldName = "PART_NO";
        //        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        //        col.Width = Unit.Pixel(80);
        //    });

        //Grv.Columns.Add(
        //    col => {
        //        col.Name = "PartName";
        //        col.Caption = "Part Name";
        //        col.FieldName = "PART_NAME";
        //        col.Width = Unit.Pixel(180);
        //    });

        Grv.Columns.Add(
            col => {
                col.Name = "QtyReceive";
                col.Caption = "Qty<br>Receive";
                col.FieldName = "QTY_RECEIVE";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col => {
                col.Name = "ReceivingArea";
                col.Caption = "Receiving<br>Area";
                col.FieldName = "RECEIVING_AREA";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                // add by alira.agi 2015-04-09
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdDock = col.PropertiesEdit as ComboBoxProperties;
                cmdDock.DropDownStyle = DropDownStyle.DropDown;
                List<DockPlant> DockPlants = Model.GetModel<List<DockPlant>>();
                cmdDock.DataSource = DockPlants;
                cmdDock.TextFormatString = "{0}";
                cmdDock.ValueField = "DockCode";
                cmdDock.Columns.Add("DockCode", "Dock Code", 100);
                cmdDock.Columns.Add("PlantName", "Plant Name", 100);
            });
	//remark by alira.agi 2015-04-14
        //Grv.Columns.Add(
        //    col =>
        //    {
        //        col.Name = "CreatedBy";
        //        col.Caption = "Created By";
        //        col.FieldName = "CREATED_BY";
        //        col.Width = Unit.Pixel(80);
        //    });

        //Grv.Columns.Add(
        //    col =>
        //    {
        //        col.Name = "CreatedDate";
        //        col.Caption = "Created Date";
        //        col.FieldName = "CREATED_DT";
        //        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        //        col.Width = Unit.Pixel(60);
                
        //        col.ColumnType = MVCxGridViewColumnType.DateEdit;
        //        var deProperties = col.PropertiesEdit as DateEditProperties;
        //        deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
        //    });
        
        //Grv.Columns.Add(
        //    col =>
        //    {
        //        col.Name = "ChangedBy";
        //        col.Caption = "ChangedBy";
        //        col.FieldName = "CHANGED_BY";
        //        col.Width = Unit.Pixel(80);
        //    });

        //Grv.Columns.Add(
        //    col =>
        //    {
        //        col.Name = "ChangedDate";
        //        col.Caption = "Changed Date";
        //        col.FieldName = "CHANGED_DT";
        //        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        //        col.Width = Unit.Pixel(60);
                
        //        col.ColumnType = MVCxGridViewColumnType.DateEdit;
        //        var deProperties = col.PropertiesEdit as DateEditProperties;
        //        deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
        //    });
        
        
        ///set value for call from javascript
        Grv.CustomJSProperties = (s, e) =>
        {
            MVCxGridView grid = (MVCxGridView)s;

            //Changed By FID.Reggy
            int StartIndex = 0;
            //int StartIndex = grid.PageIndex * grid.SettingsPager.PageSize;
            int EndIndex = Model.GetModel<List<SPReceive>>() != null ? Model.GetModel<List<SPReceive>>().Count :
                           Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);
            //int EndIndex = Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);

            object[] ProductionMonth = new object[EndIndex - StartIndex];
            object[] SupplierCode = new object[EndIndex - StartIndex];
            //object[] PartNo = new object[EndIndex - StartIndex];
            object[] QtyReceive = new object[EndIndex - StartIndex];
            object[] ReceivingArea = new object[EndIndex - StartIndex];

            for (int i = StartIndex; i < EndIndex; i++)
            {
                ProductionMonth[i - StartIndex] = grid.GetRowValues(i, "PROD_MONTH");
                SupplierCode[i - StartIndex] = grid.GetRowValues(i, "SUPPLIER_CD");
                //PartNo[i - StartIndex] = grid.GetRowValues(i, "PART_NO");
                QtyReceive[i - StartIndex] = grid.GetRowValues(i, "QTY_RECEIVE");
                ReceivingArea[i - StartIndex] = grid.GetRowValues(i, "RECEIVING_AREA");
            }

            e.Properties["cpProductionMonth"] = ProductionMonth;
            e.Properties["cpSupplierCode"] = SupplierCode;
            //e.Properties["cpPartNo"] = PartNo;
            e.Properties["cpQtyReceive"] = QtyReceive;
            e.Properties["cpReceivingArea"] = ReceivingArea;

            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        };
        
                
        ///set gridview when button on clicked
        Grv.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            ///set visibility filter row
            if (IsEditRow == "1" || IsEditRow == "2")
            {
                gv.Settings.ShowFilterRow = false;
                gv.Settings.ShowFilterRowMenu = false;
            }
            else
            {
                gv.Settings.ShowFilterRow = true;
                gv.Settings.ShowFilterRowMenu = true;
            }

            ///Disable checkbox when grid is editing
            if (e.ButtonType == ColumnCommandButtonType.SelectCheckbox)
            {
                if (IsEditRow == "1" || IsEditRow == "2")
                    e.Enabled = false;
            }

            ///hide default button update and cancel on gridview when row is editing
            if (e.ButtonType == ColumnCommandButtonType.Update)
                e.Visible = false;

            if (e.ButtonType == ColumnCommandButtonType.Cancel)
                e.Visible = false;
        };
        
        ///disabled keyfield when grid is editing
        Grv.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) => {
            MVCxGridView gv = (MVCxGridView)sender;
            string IsEditRow = Request.Params["IsEditRow"];

            if (e.Column.FieldName == "PROD_MONTH")
            {   
                if(IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   
            }

            if (e.Column.FieldName == "SUPPLIER_CD")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }

            if (e.Column.FieldName == "PART_NO")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }

            if (e.Column.FieldName == "RECEIVING_AREA")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   
            
            if (e.Column.FieldName == "SUPPLIER_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            //if (e.Column.FieldName == "PART_NAME")
            //{
            //    e.Editor.Enabled = gv.IsNewRowEditing;
            //    e.Editor.Visible = !gv.IsNewRowEditing;
            //}

            if (e.Column.FieldName == "CREATED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
        };
    }).Bind(Model.GetModel<List<SPReceive>>()).GetHtml()